/**
 * This method which should run as a thread asks the java virtual machine
 * to force a garbage collect.
 */
final class BackgroundGarbageCollect extends Thread
{
	public void run()
	{
		System.runFinalization();
		
		try
		{
			Thread.sleep(500); // halve a second
		}
		catch(Exception e)
		{
			Statics.log("Thread.sleep(500) failed with an exception: " + e);
		}

		System.gc();

		Statics.log("freeMemory: " + Runtime.getRuntime().freeMemory() + ", maxMemory: " + Runtime.getRuntime().maxMemory() + ", totalMemory: " + Runtime.getRuntime().totalMemory());
	}
}
