import java.util.*;
import java.io.*;

class BrainSettings {
	private class BrainSettingsSetting {
		String name;
		double min, def, max;
	}

	private HashMap<String, Double []> values = new HashMap<String, Double []>();

	public BrainSettings() {
	}

	public BrainSettings(String brainMap) throws FileNotFoundException, IOException {
		if (brainMap != null)
		{
			BufferedReader in = new BufferedReader(new FileReader(brainMap));
			String line;

			while((line = in.readLine()) != null)
			{
				String key = null;
				Double value = null;
				boolean eraseSuccess = false;

				int space = line.indexOf(' ');

				key = line.substring(0, space);
				assert values.get(key) != null;
				value = new Double(line.substring(space + 1));

				Double [] prev = values.get(key);

				if (prev == null)
					prev = new Double[3];

				prev[1] = value;

				values.put(key, prev);
			}
		}
	}

	public Double getValue(String key) {
		Double [] result = values.get(key);

		if (result == null)
			return 1.0;

		return result[1];
	}
}
