import java.io.*;
import java.util.ArrayList;
import java.util.List;

final class gtp {
	public static void out(String what) {
		Statics.log("<STOP " + what);
		System.out.print(what);
	}

	public static void loop(int dimensions, boolean random_allowed, final double thinkTime, boolean deep, List<Output> outputs) throws InterruptedException {
		String version = Version.getVersion();
		double komi = 0.0;
		scene s = new scene(dimensions, false);
		player current_player = player.black;
		BufferedReader gtpPipe = new BufferedReader(new InputStreamReader(System.in));

		Statics.log("Go! v" + version);

		int moveNr = 0;
		double totalTimeLeft = -1.0;
be_done_with_it:
		for(;;) {
			String id = "";
			String line = null;
			String command = null, par = null;
			int space;

			try {
				line = gtpPipe.readLine();
			}
			catch(Exception e) {
				line = null;
			}
			if (line == null) {
				Statics.log("empty command");
				break be_done_with_it;
			}

			Statics.log("GTP> " + line);

			if (line.length() == 0)
				continue;

			// get 'id', if any
			if (Character.isDigit(line.charAt(0))) {
				int space2 = line.indexOf(' ');
				if (space2 == -1)
				{
					Statics.log("no command after id");
					break be_done_with_it;
				}

				id = line.substring(0, space2) + " ";
				line = line.substring(space2 + 1).trim();
			}

			space = line.indexOf(' ');
			if (space != -1) {
				command = line.substring(0, space).trim();
				par = line.substring(space + 1).trim();
			}
			else {
				command = line.trim();
				par = null;
			}
id = "= ";
			// parse command
			if (command.equals("protocol_version"))
				out("= 2\n\n");
			else if (command.equals("name"))
				out("= Stop\n\n");
			else if (command.equals("version"))
				out("= " + version + "\n\n");
			else if (command.equals("known_command"))
				out("= false\n\n");
			else if (command.equals("list_commands")) {
				out("= protocol_version\n");
				out("name\n");
				out("version\n");
				out("known_command\n");
				out("list_commands\n");
				out("quit\n");
				out("boardsize\n");
				out("time_settings\n");
				out("time_left\n");
				out("cgos-opponent_name\n");
// FIXME implement "undo"
				out("clear_board\n");
				out("komi\n");
				out("final_score\n");
				out("play\n");
				out("genmove\n");
				out("place_free_handicap\n");
				out("set_free_handicap\n");
				out("kgs-game_over\n");		// KGS specific
				out("\n");
			}
			else if (command.equals("kgs-game_over"))	// KGS specific
				System.exit(0);
			else if (command.equals("quit")) {
				try {
					out("\n\n"); // required for twogtp
					Thread.yield();
					Thread.sleep(100);
				}
				catch(Exception e) {
				}
				finally {
					System.exit(0);
				}
			}
			else if (command.equals("boardsize")) {
				dimensions = Integer.valueOf(par);
				s = new scene(dimensions, false);
				current_player = player.black;
				out("= \n\n");
			}
			else if (command.equals("cgos-opponent_name")) {
				Statics.log("opponent: " + par);
				out("= \n\n");
			}
			else if (command.equals("clear_board")) {
				s = new scene(dimensions, false);
				current_player = player.black;
				out("= \n\n");
				moveNr = 0;
				totalTimeLeft = -1.0;
			}
			else if (command.equals("komi")) {
				komi = Double.valueOf(par);
				out("= \n\n");
			}
			else if (command.equals("time_left")) {
				String [] parts = par.split(" ");

				totalTimeLeft = Double.valueOf(parts[1]);

				Statics.log("think time left: " + totalTimeLeft);
				out("= \n\n");
			}
			else if (command.equals("time_settings")) {
				String [] parts = par.split(" ");

				totalTimeLeft = Double.valueOf(parts[0]);

				Statics.log("think time: " + totalTimeLeft);
				out("= \n\n");
			}
			else if (command.equals("play")) {
				int space3 = par.indexOf(' ');
				if (space3 == -1) {
					Statics.log("play requires 2 parameters, got only 1");
					break be_done_with_it;
				}

				String move = par.substring(space3 + 1).trim();
				player color = (par.substring(0, space3).equalsIgnoreCase("white") || par.substring(0, space3).equalsIgnoreCase("w")) ? player.white : player.black;

				if (move.equalsIgnoreCase("pass")) {
					Statics.log(move + " for " + color);
				}
				else {
					int x = Character.toUpperCase(move.charAt(0)) - 'A';
					int y = Integer.valueOf(move.substring(1)) - 1;

					if (x == 8)
						Statics.log("Got an I-file!");

					if (x > 8)	// the I-file is never used
						x--;

					scene oldScene = s;
					s = s.doMove(x, y, color == player.white ? cross.white : cross.black, color);
					oldScene.destructor();

					Statics.log("" + color + " moves " + x + "," + y);
					//Statics.logBoard(s.getBoard(), "am ");
				}

				// current_player = (current_player == player.white) ? player.black : player.white;
				out("= \n\n");
			}
			else if (command.equals("genmove") || command.equals("genmove_white") || command.equals("genmove_black")) {
				int underscore = command.indexOf('_');
				if (underscore != -1)
					par = command.substring(underscore + 1);

				player color = (par.equalsIgnoreCase("white") || par.equalsIgnoreCase("w")) ? player.white : player.black;

				double thinkTimeTemp = thinkTime;
				if (totalTimeLeft > 0) {
					int nFreedoms = s.getNFreedoms(color);

					if (nFreedoms == 0)
						nFreedoms = 1; // decideMove will return pass in this case

					Statics.log("total think time left: " + totalTimeLeft + ", number of freedoms left: " + nFreedoms);

					// https://webdisk.lclark.edu/drake/publications/time-poster-2013.pdf
					// 0.55 instead of 0.5: other end may do 'pass'
					// depend on (dit is 'C') how many stones are of us?
					thinkTimeTemp = totalTimeLeft / (0.55 * nFreedoms);

					if (thinkTimeTemp <= 0.0)
						thinkTimeTemp = thinkTime;
				}

				Statics.log("Will think for " + thinkTimeTemp + " seconds");

				SelectedMove selectedMove = s.decideMove(color, random_allowed, deep, thinkTimeTemp, outputs, moveNr++);

				if (selectedMove == null) {
					out("= pass\n\n");
				}
				else {
					int x = selectedMove.getX();
					int y = selectedMove.getY();

					Statics.log("Genmove: " + color + " " + x + "," + y);
					s = s.doMove(x, y, color == player.white ? cross.white : cross.black, color);
					Statics.logBoard(s.getBoard(), "am ");

					if (x >= 8)	// this is needed to skip the 'i'
						x++;
					out("= " + (char)('A' + x) + "" + (1 + y) + "\n\n");
				}

				// current_player = (current_player == player.white) ? player.black : player.white;
			}
			else if (command.equals("final_score")) {
				double white_score = (double)s.getWhitePoints() + komi;
				double black_score = (double)s.getBlackPoints();

				if (white_score > black_score)
					out("= W+" + white_score + "\n\n");
				else
					out("= B+" + black_score + "\n\n");
			}
			else if (command.equals("place_free_handicap") || command.equals("set_free_handicap")) {
				do {
					int x, y;
					space = par.indexOf(" ");

					x = Character.toUpperCase(par.charAt(0)) - 'A';
					if (space != -1)
						y = Integer.valueOf(par.substring(1, space)) - 1;
					else
						y = Integer.valueOf(par.substring(1)) - 1;

					if (x == 8)
						Statics.log("Got an I-file!");
					if (x > 8)	// the I-file is never used
						x--;

					Statics.log("black at " + x + "," + y);
					s.getBoard().putAt(x, y, cross.black);

					if (space != -1)
						par = par.substring(space + 1).trim();
				}
				while(space != -1);

				out("= \n\n");

				Statics.log("board after free_handicap:");
				Statics.logBoard(s.getBoard(), "fh ");
			}
			else {
				Statics.log("?" + id + " " + line + ": not understood");
				out("?" + id + " " + line + ": not understood\n\n");
			}
		}
	}
}
